byte fsm = 0;
byte next_fsm = 0;

#define wait_rfid 2
#define wait_temp 3
#define wait_serial 30

#define no_card 0

int rfid_count = 0;
int temp_count = 0;

byte lido_rfid;
String lido_serial;

float temp_value;

int buttom;

void ler_buttom(){
 buttom = digitalRead(button_pin); 
}

void ler_rfid(){
  lido_rfid = get_rfid();
  if(lido_rfid){
   //UuiCpy(mfrc522.uid.uidByte);
  }
}

void envia_rfid(){
  PrintUid(mfrc522.uid.uidByte);
}
void ler_serial(){
  lido_serial = "";
  while(Serial.available()){
      lido_serial += (char)Serial.read();
  }
}
void avisa(){
      Serial.println("nao autenticou");
}
void set_rele(bool on_off){
  if(on_off){
    digitalWrite(rele_pin, HIGH);
  }
  else {
    digitalWrite(rele_pin, LOW);    
  }
}
void check_temp(){
  temp_value = get_temperature();
}
void send_temp(){
  Serial.println(temp_value);
}


void state_machine_1(){
  fsm = next_fsm;
  Serial.println(fsm);
  delay(100);
  
  switch(fsm){
    case 0:
      rfid_count = 0;
      next_fsm = 1;
    break;
    case 1:
    if(rfid_count++ >= wait_rfid){
      next_fsm = 2;
    }
    else{
      next_fsm = 1;
    }
    break;
    case 2:
      ler_rfid();
      if(lido_rfid == no_card){
        next_fsm = 1;
      }
      else{
        next_fsm = 3;  
      }
    
    break;
    case 3:
      envia_rfid();
      rfid_count = 0;
      next_fsm = 4;
    break;
    case 4:
    ler_serial();
      if(lido_serial){
        next_fsm = 6;
      }
      else if(rfid_count++ >= wait_serial){
        next_fsm = 5;
      }
      else if(!lido_serial){
        next_fsm = 4;
      }
    break;
    case 5:
      avisa();
      rfid_count = 0;
      next_fsm = 1;
    break;
    case 6:
    ler_buttom();
      if(buttom == 0){
        next_fsm = 6;
      }
      else {
        next_fsm = 7;
      }
    break;
    case 7:
    ler_buttom();
      if(buttom == 1){
        next_fsm = 7;
      }
      else {
        next_fsm = 8;
      }
    break;
    case 8:
      set_rele(true);
      next_fsm = 9;
    break;
    case 9:
      check_temp();
      next_fsm = 10;
    break;
    case 10:
      send_temp();
      temp_count = 0;
      next_fsm = 11;
    break;
    case 11:
      
      if(!lido_serial && (temp_count++ < wait_temp)){
        next_fsm = 11;
      }
      else if(lido_serial){
        next_fsm = 12;
      }
      else {
        next_fsm = 9;
      }
    break;
    case 12:
      avisa();
      next_fsm = 13;
    break;
    case 13:
      set_rele(false);
      next_fsm = 1;
    break;
  }
}

