#include <SPI.h>
#include "MFRC522.h"

#include <OneWire.h>
#include <DallasTemperature.h>
#include <Servo.h>

Servo myservo1;
Servo myservo2;

#define a1_oeste A0
#define a2_leste A1
#define a3_norte A2
#define a4_sul A3


#define servo_1 9
#define servo_2 10
 
#define ONE_WIRE_BUS 7
 

#define RST_PIN         29        
#define SS_PIN          SDA  

#define button_pin PD6
#define rele_pin D4


MFRC522 mfrc522(SS_PIN, RST_PIN);
OneWire oneWire(ONE_WIRE_BUS);
 

DallasTemperature sensors(&oneWire);
DeviceAddress sensor1;


void setup(){
    Serial.begin(9600);  
    rfid_setup();
    set_temp_sensor();
    //set_solar();
  
}

void loop() {

  state_machine_1();
  //solar_control();
  
}

