//Módulo para controle da base do painel solar, afim de conseguir maximo aproveitamento do painel.
//Para tal foram usados dois servomecanismos 9g e quatro LRD's para realimentação.
//A1 oeste
//A2 leste
//A3 norte
//A4 sul


float pos1 = 90.0;    // variable to store the servo position
float pos2 = 90.0;    // variable to store the servo position


float error1;
float error2;
void set_solar() {
  myservo1.attach(9);
  myservo2.attach(10);
  
  pinMode(A0, INPUT);
  pinMode(A1, INPUT);
  pinMode(A2, INPUT);
  pinMode(A3, INPUT);

}

void solar_control() {
  error1 = analogRead(A0)-analogRead(A1);
  error2 = analogRead(A2)-0.9*analogRead(A3);
  pos1 = pos1 + 0.08*error1;
  pos2 = pos2 + 0.08*error2;
  pos1 = abs(pos1);
  pos2 = abs(pos2);
  
  if(pos1>180) pos1 = 180;
  if(pos2>180) pos2 = 180;

	
  myservo1.write(pos1);
  myservo2.write(pos2);
  //delay(15);
}
